/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * HarvestBackend
 */

public class HarvestBackend {
  @JsonProperty("features")
  private List<HarvestFeature> features = null;

  @JsonProperty("filters")
  private List<HarvestFilter> filters = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("label")
  private String label = null;

  public HarvestBackend features(List<HarvestFeature> features) {
    this.features = features;
    return this;
  }

  public HarvestBackend addFeaturesItem(HarvestFeature featuresItem) {
    if (this.features == null) {
      this.features = new ArrayList<HarvestFeature>();
    }
    this.features.add(featuresItem);
    return this;
  }

   /**
   * The backend optional features
   * @return features
  **/
  @ApiModelProperty(value = "The backend optional features")
  public List<HarvestFeature> getFeatures() {
    return features;
  }

  public void setFeatures(List<HarvestFeature> features) {
    this.features = features;
  }

  public HarvestBackend filters(List<HarvestFilter> filters) {
    this.filters = filters;
    return this;
  }

  public HarvestBackend addFiltersItem(HarvestFilter filtersItem) {
    if (this.filters == null) {
      this.filters = new ArrayList<HarvestFilter>();
    }
    this.filters.add(filtersItem);
    return this;
  }

   /**
   * The backend supported filters
   * @return filters
  **/
  @ApiModelProperty(value = "The backend supported filters")
  public List<HarvestFilter> getFilters() {
    return filters;
  }

  public void setFilters(List<HarvestFilter> filters) {
    this.filters = filters;
  }

  public HarvestBackend id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The backend identifier
   * @return id
  **/
  @ApiModelProperty(value = "The backend identifier")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public HarvestBackend label(String label) {
    this.label = label;
    return this;
  }

   /**
   * The backend display name
   * @return label
  **/
  @ApiModelProperty(value = "The backend display name")
  public String getLabel() {
    return label;
  }

  public void setLabel(String label) {
    this.label = label;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HarvestBackend harvestBackend = (HarvestBackend) o;
    return Objects.equals(this.features, harvestBackend.features) &&
        Objects.equals(this.filters, harvestBackend.filters) &&
        Objects.equals(this.id, harvestBackend.id) &&
        Objects.equals(this.label, harvestBackend.label);
  }

  @Override
  public int hashCode() {
    return Objects.hash(features, filters, id, label);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HarvestBackend {\n");

    sb.append("    features: ").append(toIndentedString(features)).append("\n");
    sb.append("    filters: ").append(toIndentedString(filters)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    label: ").append(toIndentedString(label)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

